#include "kernel.h"

__device__ TestStruct D_TestA;
__device__ TestStruct D_TestB;
__device__ TestStruct D_TestC;
__device__ TestStruct D_TestD;
__device__ TestStruct D_TestE;
__device__ TestStruct D_TestF;
__device__ TestStruct D_TestG;
__device__ TestStruct D_TestH;
__device__ TestStruct D_TestI;
__device__ TestStruct D_TestJ;
__device__ TestStruct D_TestK;
__device__ TestStruct D_TestL;
__device__ TestStruct D_TestM;
__device__ TestStruct D_TestN;
__device__ TestStruct D_TestO;
__device__ TestStruct D_TestP;
__device__ TestStruct D_TestQ;
__device__ TestStruct D_TestR;
__device__ TestStruct D_TestS;
__device__ TestStruct D_TestT;
__device__ TestStruct D_TestU;
__device__ TestStruct D_TestV;
__device__ TestStruct D_TestW;
__device__ TestStruct D_TestX;
__device__ TestStruct D_TestY;
__device__ TestStruct D_TestZ;
__device__ TestStruct D_TestA1;

__global__ void DevTest(float *devTestValue, float srcTestValue)
{
	// These definitions all works fine. Only used to accumulate to the address where the error occurs.
	D_TestA = TestStruct();
	D_TestB = TestStruct();
	D_TestC = TestStruct();
	D_TestD = TestStruct();
	D_TestE = TestStruct();
	D_TestF = TestStruct();
	D_TestG = TestStruct();
	D_TestH = TestStruct();
	D_TestI = TestStruct();
	D_TestJ = TestStruct();
	D_TestK = TestStruct();
	D_TestL = TestStruct();
	D_TestM = TestStruct();
	D_TestN = TestStruct();
	D_TestO = TestStruct();
	D_TestP = TestStruct();
	D_TestQ = TestStruct();
	D_TestR = TestStruct();
	D_TestS = TestStruct();
	D_TestT = TestStruct();
	D_TestU = TestStruct();
	D_TestV = TestStruct();
	D_TestW = TestStruct();
	D_TestX = TestStruct();
	D_TestY = TestStruct();
	D_TestZ = TestStruct();

	// Error is generated here: "access violation at address 0x0000a400"
	// While actual address of D_TestA1 is 0x0107a400!
	// Error only occurs if debug information for the device is generated (-G0)
	D_TestA1 = TestStruct();

	// Store a value in D_TestA1, then copy to devTestValue.
	// Make sure reading and writing to D_TestA1 is actually done when no debug information is generated.
	D_TestA1.a = 10;
	devTestValue[0] = D_TestA1.a;
}

int main()
{
	CudaExe(cudaSetDevice(0));

	float *devTestValue = NULL;
	float srcTestValue = 10;
	float dstTestValue = 0;
	CudaExe(cudaMalloc((void**)&devTestValue, sizeof(float)));

	// Copy value to struct and from there to devTestValue.
	// Will fail if access violation occurs
	DevTest<<<1, 1>>>(devTestValue, srcTestValue);

	// Synchronize to catch any kernel errors
	CudaExe(cudaDeviceSynchronize());

	// Copy test value back to host
	CudaExe(cudaMemcpy((void**)&dstTestValue, devTestValue, sizeof(float), cudaMemcpyDeviceToHost));
	
	// Reset
	CudaExe(cudaDeviceReset());

	std::cout << " Value: " << dstTestValue << std::endl;
	// Make sure the value was copied correctly
	if(dstTestValue == srcTestValue)
	{
		std::cout << " Success. Press any key to exit." << std::endl;
		getchar();
		return 0;
	}
	std::cout << " Test failed. Press any key to exit." << std::endl;
	getchar();
	return 1;
}

void CudaExe(cudaError_t err)
{
	if(err != cudaSuccess)
	{
		std::cout << " Cuda Error: " << cudaGetErrorString(err) << ". Press any key to exit" << std::endl;
		getchar();
		exit(1);
	}
}